#include <windows.h>

#include "bmslsort.h"

// *.init@C̃pX
char ini_filename[MAX_PATH];
// ݊JĂBMSt@C
BmsBms *bms = NULL_BMS;
// ݊JĂBMSt@C̃pX
char bms_path[MAX_PATH];
char bms_dir[MAX_PATH];

// init@C擾֐
static bool get_ini_filename( void );

// R}hC - 1ڂ̃t@C擾
static bool get_first_cmd_line( PSTR cmd_line, char *out );


// Gg|Cg
int WINAPI WinMain( HINSTANCE h_instance,
                    HINSTANCE h_prev_instance,
                    PSTR lp_cmd_line,
                    int n_cmd_show )
{
  h_prev_instance; // x̗}̈

  // init@C擾 => ini_filename
  get_ini_filename();

  char open_filename[MAX_PATH];
  // R}hC - 1ڂ̃t@C擾
  if ( get_first_cmd_line( lp_cmd_line, open_filename ) ) {
    // R}hCŃt@CnꂽBMSt@C
    if ( BmsLexer::read_file( open_filename, &bms ) ) {
      set_bms_path_dir( open_filename, true, true );
    }
  }
  if ( bms == NULL_BMS ) {
    bms = new BmsBms();
    set_bms_path_dir( "", false, false );
  }

  // EBhENX̍쐬Ao^
  WNDCLASS window_class;
  window_class.style         = CS_HREDRAW | CS_VREDRAW;
  window_class.lpfnWndProc   = main_wind_proc;
  window_class.cbClsExtra    = 0;
  window_class.cbWndExtra    = 0;
  window_class.hInstance     = h_instance;
  window_class.hIcon         = LoadIcon( h_instance, "MAIN_ICON" );
  window_class.hCursor       = LoadCursor( NULL, IDC_ARROW );
  window_class.hbrBackground = NULL;//(HBRUSH)GetStockObject( LTGRAY_BRUSH );
  window_class.lpszMenuName  = "MAIN_MENU";
  window_class.lpszClassName = MAIN_WIND_CLASSNAME;

  if ( !RegisterClass( &window_class ) ) {
    MessageBox( NULL, "EBhENX̓o^Ɏs܂", "ERROR", MB_OK | MB_ICONERROR );
    return -1;
  }

  // EBhE̍쐬
  HWND h_wnd = CreateWindowEx(
    WS_EX_STATICEDGE | WS_EX_ACCEPTFILES,
    MAIN_WIND_CLASSNAME,
    APP_NAME,
    WS_OVERLAPPEDWINDOW,
    GetPrivateProfileInt( INI_SECTION_WINDOW, INI_POINT_X, CW_USEDEFAULT, ini_filename ),
    GetPrivateProfileInt( INI_SECTION_WINDOW, INI_POINT_Y, CW_USEDEFAULT, ini_filename ),
    GetPrivateProfileInt( INI_SECTION_WINDOW, INI_WIDTH, WIND_WIDTH_DEFAULT, ini_filename ),
    GetPrivateProfileInt( INI_SECTION_WINDOW, INI_HEIGHT, WIND_HEIGHT_DEFAULT, ini_filename ),
    NULL,
    NULL,
    h_instance,
    NULL
    );
  if ( h_wnd == NULL ) {
    MessageBox( NULL, "EBhE쐬Ɏs܂", "ERROR", MB_OK | MB_ICONERROR );
    return -1;
  }
  ShowWindow( h_wnd , n_cmd_show );

  // bZ[Wҋ@[v
  MSG msg;
  while ( GetMessage( &msg, NULL, 0, 0 ) ) {
    TranslateMessage( &msg );
    DispatchMessage( &msg );
  }

  return msg.wParam;
}


// init@C擾֐
static bool get_ini_filename( void ) {
  char full_path[MAX_PATH];
  char drive[MAX_PATH], dir[MAX_PATH], filename[MAX_PATH], ext[MAX_PATH];

  GetModuleFileName( NULL, full_path, MAX_PATH );

  //tpX𕪊
  _splitpath( full_path, drive, dir, filename, ext);

  wsprintf( ini_filename, "%s%s%s.ini", drive, dir, filename );

  return true;
}


// R}hC - 1ڂ̃t@C擾
static bool get_first_cmd_line( PSTR cmd_line, char *out ) {

  if ( cmd_line[0] == '\0' ) { return false; }

  bool double_c_flag = false;

  for ( int i = 0; i < MAX_PATH; ++i ) {
    *(out) = cmd_line[i];

    if ( *(out) == '\"' ) { double_c_flag = !double_c_flag; --out; }
    if ( double_c_flag == false && *(out) == ' ' ) { *(out) = '\0'; break; }
    ++out;
  }
  return true;
}
